'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = universal;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _requireUniversalModule = require('require-universal-module');

var _requireUniversalModule2 = _interopRequireDefault(_requireUniversalModule);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var DefaultLoading = function DefaultLoading() {
  return _react2.default.createElement(
    'div',
    null,
    'Loading...'
  );
};
var DefaultError = function DefaultError() {
  return _react2.default.createElement(
    'div',
    null,
    'Error!'
  );
};

var isServer = typeof window === 'undefined';
var DEV = process.env.NODE_ENV === 'development';

function universal(component) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var _opts$loading = opts.loading,
      Loading = _opts$loading === undefined ? DefaultLoading : _opts$loading,
      _opts$error = opts.error,
      Err = _opts$error === undefined ? DefaultError : _opts$error,
      _opts$minDelay = opts.minDelay,
      minDelay = _opts$minDelay === undefined ? 0 : _opts$minDelay,
      options = _objectWithoutProperties(opts, ['loading', 'error', 'minDelay']);

  var _req = (0, _requireUniversalModule2.default)(component, options),
      requireSync = _req.requireSync,
      requireAsync = _req.requireAsync,
      addModule = _req.addModule,
      mod = _req.mod;

  var Component = mod; // initial syncronous require attempt done for us :)

  return function (_React$Component) {
    _inherits(UniversalComponent, _React$Component);

    _createClass(UniversalComponent, null, [{
      key: 'preload',
      value: function preload() {
        requireAsync().catch(function (e) {
          if (DEV) console.warn('[react-universal-component] preload failed:', e);
        });
      }
    }]);

    function UniversalComponent(props) {
      _classCallCheck(this, UniversalComponent);

      var _this = _possibleConstructorReturn(this, (UniversalComponent.__proto__ || Object.getPrototypeOf(UniversalComponent)).call(this, props));

      _this.update = function (state) {
        if (!_this._mounted) return;
        _this.setState(state);
      };

      if (!Component) {
        // try one more syncronous require, in case chunk comes after main.js
        // HMR won't work if you've setup your app this way. `mod` must be
        // assigned to `Component` in the closure for HMR to work.
        Component = requireSync();
      }

      _this.state = {
        error: null,
        hasComponent: !!Component
      };
      return _this;
    }

    _createClass(UniversalComponent, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        var _this2 = this;

        this._mounted = true;
        addModule(); // record the module for SSR flushing :)

        if (this.state.hasComponent || isServer) return;
        var time = new Date();

        requireAsync(this.props).then(function (mod) {
          Component = mod; // for HMR updates component must be in closure
          var state = { hasComponent: !!Component };

          var timeLapsed = new Date() - time;
          if (timeLapsed < minDelay) {
            var extraDelay = minDelay - timeLapsed;
            return setTimeout(function () {
              return _this2.update(state);
            }, extraDelay);
          }
          _this2.update(state);
        }).catch(function (error) {
          return _this2.update({ error: error });
        });
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this._mounted = false;
      }
    }, {
      key: 'render',
      value: function render() {
        var _state = this.state,
            error = _state.error,
            hasComponent = _state.hasComponent;

        var _props = this.props,
            isLoading = _props.isLoading,
            userError = _props.error,
            props = _objectWithoutProperties(_props, ['isLoading', 'error']);

        // user-provided props (e.g. for data-fetching loading):


        if (isLoading) {
          return createElement(Loading, props);
        } else if (userError) {
          return createElement(Err, _extends({}, props, { error: userError }));
        } else if (hasComponent && Component) {
          // primary usage (for async import loading + errors):
          return createElement(Component, props);
        } else if (error) {
          return createElement(Err, _extends({}, props, { error: error }));
        }

        return createElement(Loading, props);
      }
    }]);

    return UniversalComponent;
  }(_react2.default.Component);
}

var createElement = function createElement(Component, props) {
  return _react2.default.isValidElement(Component) ? _react2.default.cloneElement(Component, props) : _react2.default.createElement(Component, props);
};